#pragma once
#include "CoordinateTransformation.h"

class Camera
{
public:
	Camera(CoordinateTransformation& ct)
		: ct(ct)
	{

	}

	Vec2 GetPosition() const
	{
		return position;
	}

	void MoveTo(Vec2 _position)
	{
		position = _position;
	}

	void MoveBy(Vec2 offset)
	{
		position -= offset;
	}

	void Draw(Drawable& drawable)
	{
		drawable.Translate(position);
		drawable.Scale(scale);
		ct.Draw(drawable);
	}

	~Camera() {};

	float GetScale() const
	{
		return scale;
	}

	void SetScale(float _scale)
	{
		scale = _scale;
	}

private:
	CoordinateTransformation& ct;
	Vec2 position = { 0.0f, 0.0f };
	float scale = 1.0f;
};
